## States
# 1 : Born : NOW
# 2 : Sneak : OW
# 3 : Idle : OW, Always go back to Idle
# 4 : Walk : OW
# 5 : Jump : OW
## OW = Over Writable

# Spawn
execute unless score state cart_vars matches 1.. run function snc:shifters/mobs/cart/spawn/init
# Always in combat while transformed
scoreboard players set warn cart_vars 600

## Health system
# When doesn't have absortion then add tag 'injured'
execute store result score health cart_vars run data get entity @s AbsorptionAmount
execute store result bossbar cart_health value run scoreboard players get health cart_vars
# Kill when time runs out
execute if score minutes cart_vars matches ..0 if score seconds cart_vars matches ..0 run function snc:shifters/mobs/cart/remove/transform
# Kill when life is 0
execute if score health cart_vars matches ..0 run function snc:shifters/mobs/cart/remove/transform_when_hurt

# Enable Walking
execute unless score state cart_vars matches 5.. if score @s player_walking matches 1.. run scoreboard players set state cart_vars 4
execute unless score state cart_vars matches 5.. if predicate snc:is_sprinting run scoreboard players set state cart_vars 4
execute if score state cart_vars matches 3.. run scoreboard players set height cart_vars 4
scoreboard players set @s player_walking 0

## JUMP
# If is not jumping and the player jumps
# then jump
# when player hits ground set jump back to idle
## Variables
# state 5 : is jumping
# on_floor : is on floor
execute unless score state cart_vars matches 6.. if score on_floor cart_vars matches 1 if score @s player_jumping matches 1.. run function snc:shifters/mobs/cart/action/movement/init

# Place Barrier Blocks
execute if score state cart_vars matches 2 unless block ~ ~-2.5 ~ #snc:filter_shifter rotated ~ 0 run function snc:shifters/mobs/cart/action/movement/floor
execute unless score state cart_vars matches 2 unless block ~ ~-5 ~ #snc:filter_shifter rotated ~ 0 run function snc:shifters/mobs/cart/action/movement/floor

# Rotation
execute store result score player_rotation cart_vars run data get entity @s Rotation[0]

# Keep height
function snc:shifters/mobs/cart/action/movement/height

## SNEAK
execute unless score state cart_vars matches 6.. if predicate snc:is_sneaking run scoreboard players set state cart_vars 2
execute if score state cart_vars matches 2 run scoreboard players set height cart_vars 1

effect give @s slow_falling 3 0 true
effect give @s invisibility 2 0 true
effect give @s resistance 3 1 true
effect give @s saturation 1 0 true

# Select Attack If is not attacking
execute unless score state cart_vars matches 10.. if score action cart_vars matches ..0 if score @s using_carrot matches 1.. run function snc:shifters/select_using_carrot

# If is going to attack
# execute if score state cart_vars matches 10.. if score action cart_vars matches ..0 run function snc:shifters/select_atk

## Depends on the Shifter
# Store motion in Y
execute store result score motion cart_vars run data get entity @s Motion[1] 10000
execute if score motion cart_vars matches ..0 run scoreboard players set @s player_jumping 0

# Set state_tp
function snc:shifters/mobs/cart/action/movement/select_state

# Kill cart
execute if predicate snc:is_riding_turret run scoreboard players set kill_pos_2 cart_vars 1